
while_stat < TWhileStat: TStat > :
   "while"
   "(" cond:expr ")"
   code:inner_stat ;

if_stat < TIfStat: TStat >  :
   "if"
   "(" cond:expr ")"
   then_code:inner_stat
   (
      <new_line>
      "else"
      else_code:inner_stat
   )?   ;

coumpund_stat < TCompoundStat: TSTat > :
   "{"
    <indent>
    (
       <new_line>
       <add> stat
    )*
   <unindent>
   <new_line>
    "}" ;

simple_stat < TSimpleStat: TStat >:
   subexpr:expr
   ";" ;

empty_stat < TEmptyStat: TStat > :
   ";" ;

stat < select TStat > :
   while_stat | if_stat | coumpund_stat | simple_stat | empty_stat ;

inner_stat < return TStat > :
   <new_line>
   <indent>
   stat
   <unindent > ;

program < return TStat >:
   stat ;


< struct CmmExpr { enum kind; } >
< struct CmmBinaryExpr : CmmExpr {  } >
   
simple_expr <TSimpleExpr:CmmExpr, kind=simpleExp> :
   name:identifier | value:number  | "(" subexpr:expr ")" ;

multiplicative_expr <choose CmmExpr>:
  simple_expr
  (
    <new CmmMulExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    ( '*' <set kind=mulExp> |
      '/' <set kind=divExp> |
      '%' <set kind=modExp> )
    right:simple_expr
  )* ;

additive_expr <choose CmmExpr>:
  multiplicative_expr
  (
    <new CmmAddExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    ( '+' <set kind=addExp> |
      '-' <set kind=subExp> )
    right:multiplicative_expr
  )* ;

relational_expr <choose CmmExpr>:
  additive_expr
  (
    <new CmmRelExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    ( '<'  <set kind=ltExp> |
      '>'  <set kind=gtExp> |
      "<=" <set kind=leExp> |
      ">=" <set kind=geExp> )
    right:additive_expr
  )* ;

equality_expr <choose CmmExpr>:
  relational_expr
  (
    <new CmmEqExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    ( "==" <set kind=eqExp> |
      "!=" <set kind=neExp> )
    right:relational_expr
  )* ;

logical_and_expr <choose CmmExpr>:
  equality_expr
  (
    <new CmmAndAndExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    "&&" <set kind=logAndExp>
    right:equality_expr
  )* ;

logical_or_expr <choose CmmExpr>:
  logical_and_expr
  (
    <new CmmOrOrExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    "||" <set kind=logOrExp>
    right:logical_and_expr
  )* ;

assignment_expr <choose CmmExpr>:
  logical_or_expr
  (
    <new CmmAssignExpr:CmmBinaryExpr>
    <store left:CmmExpr>
    ( '='   <set kind=assignExp>    )
    right:assignment_expr
  )? ;

expr <return TExpr> :
   assignment_expr;


