#!/usr/bin/env python

from __future__ import print_function

# import sys, os, re

from util import use_qt5
if use_qt5 :
   from PyQt5.QtCore import *
   from PyQt5.QtGui import *
   from PyQt5.QtWidgets import *
else :
   from PyQt4.QtCore import *
   from PyQt4.QtGui import *

from util import findColor, findIcon

# --------------------------------------------------------------------------

class Options (QDialog) :
   def __init__ (self, win) :
       super (Options, self).__init__ (win)

       self.setWindowTitle ("Options")
       # self.setStyleSheet ("QTabBar::tab:selected { color: orange; } QLineEdit {border: 1px solid green; } QLineEdit:focus {border: 1px solid red; }")

       self.section1 = QTabWidget ()

       self.tab1 = QWidget ()

       self.edit = QLineEdit ()

       self.checkBox = QCheckBox ()
       self.checkBox.setText ("something")

       self.tab1_layout = QVBoxLayout ()
       self.tab1_layout.addWidget (self.edit)
       self.tab1_layout.addWidget (self.checkBox)
       self.tab1.setLayout (self.tab1_layout)

       self.tab2 = QWidget ()

       self.section1.addTab (self.tab1, "first")
       self.section1.addTab (self.tab2, "second")

       self.section2 = QWidget ()

       self.stackWidget = QStackedWidget ()
       self.stackWidget.addWidget (self.section1)
       self.stackWidget.addWidget (self.section2)

       self.button1 = QPushButton ()
       self.button1.setText ("edit")
       self.button1.setIcon (findIcon ("edit-undo"))
       self.button1.setMinimumSize (80, 80)
       self.button1.clicked.connect (lambda: self.stackWidget.setCurrentIndex (0))

       self.button2 = QPushButton ()
       self.button2.setText ("other")
       self.button2.setIcon (findIcon ("folder-new"))
       self.button2.setMinimumSize (80, 80)
       self.button2.clicked.connect (lambda: self.stackWidget.setCurrentIndex (1))

       self.toolBar = QToolBar ()
       self.toolBar.setOrientation (Qt.Vertical)
       self.toolBar.addWidget (self.button1)
       self.toolBar.addWidget (self.button2)

       self.buttonBox = QDialogButtonBox (QDialogButtonBox.Ok | QDialogButtonBox.Cancel)
       self.buttonBox.accepted.connect (self.accept)
       self.buttonBox.rejected.connect (self.reject)

       self.hlayout = QHBoxLayout ()
       self.hlayout.addWidget (self.toolBar)
       self.hlayout.addWidget (self.stackWidget)

       self.layout = QVBoxLayout ()
       self.layout.addLayout (self.hlayout)
       self.layout.addWidget (self.buttonBox)
       self.setLayout (self.layout)

# --------------------------------------------------------------------------

# kate: indent-width 1; show-tabs true; replace-tabs true; remove-trailing-spaces all
